<template>
    <v-card class="elevation-3">
        <Loading :visible="isLoading" />
        <v-card-title>
            Informations utilisateurs
            <v-chip v-for="role in userRoles" :key="role.value" class="ma-2" :color="role.color" dark small>
                {{role.value}}
            </v-chip>
        </v-card-title>

        <v-list-item>
            <v-list-item-content>
                <v-form>
                    <v-list-item>
                        <v-radio-group row v-model="userProfile.gender" :mandatory="false" :disabled="!editMode">
                            <v-radio label="Monsieur" value="male"></v-radio>
                            <v-radio label="Madame" value="female"></v-radio>
                        </v-radio-group>
                    </v-list-item>
                    <v-list-item>
                        <v-list-item-avatar tile size="150" color="grey" rounded>
                           <v-img :src="imageUrl" alt="Profile picture">
                           </v-img>
                        </v-list-item-avatar>
                        <v-list-item-content>
                            <v-file-input v-model="imageAvatar" accept="image/*" id="avatar" label="Choisissez votre avatar" name="avatar" @change="uploadImage"
                                prepend-icon="mdi-camera" :disabled="!editMode">
                            </v-file-input>
                        </v-list-item-content>
                    </v-list-item>
                    <v-list-item>
                            <v-row>
                                <v-col cols="4">
                                    <v-text-field id="lastName" v-model="userProfile.lastName" label="Nom"
                                        :error-messages="lastNameErrors" class="input-field" dense
                                        :disabled="!editMode">
                                    </v-text-field>
                                </v-col>
                                <v-col cols="8">
                                    <v-text-field id="firstName" v-model="userProfile.firstName" label="Prénom"
                                        :error-messages="firstNameErrors" class="input-field" dense
                                        :disabled="!editMode">
                                    </v-text-field>
                                </v-col>
                            </v-row>
                    </v-list-item>
                    <v-list-item>
                            <v-text-field id="pseudo" v-model="userProfile.alias" label="Pseudo"
                                :error-messages="aliasErrors" class="input-field" dense :disabled="!editMode">
                            </v-text-field>
                    </v-list-item>
                    <v-list-item>
                            <v-text-field id="birthday" v-model="userProfile.birthday" label="Date de naissance"
                                placeholder="00/00/0000" :error-messages="dateErrors" class="input-field"
                                v-mask="'##/##/####'" @focus="$event.target.select()" dense :disabled="!editMode">
                            </v-text-field>
                    </v-list-item>
                    <v-list-item>
                            <v-text-field id="phone" v-model="userProfile.phone" label="Téléphone"
                                :error-messages="phoneErrors" class="input-field" @focus="$event.target.select()" dense
                                :disabled="!editMode"></v-text-field>
                    </v-list-item>
                    <v-card-actions>
                        <div v-if="editMode">
                            <v-btn color="secondary" light type="submit" @click="saveInfos">
                                Sauvegarder
                            </v-btn>
                        </div>
                        <div v-else>
                            <v-btn color="secondary" light @click="editProfile">
                                Editer
                            </v-btn>
                        </div>
                    </v-card-actions>
                </v-form>
            </v-list-item-content>
        </v-list-item>
    </v-card>
</template>

<script>
import { ENTRYPOINT } from '../../config/entrypoint';
import {
  validationMixin
} from 'vuelidate';
import { mapActions } from 'vuex';
import {
  mapFields
} from 'vuex-map-fields';
import {
  required,
  minLength
} from 'vuelidate/lib/validators';
import moment from 'moment';
import Loading from '../../components/Loading';

const ROLES_COLORS = {'ROLE_COMPANY' : 'teal darken-2', 'ROLE_ADMIN' : 'red darken-2',};
const ROLES_TXT = {'ROLE_COMPANY' : 'Entreprise', 'ROLE_ADMIN' : 'Administrateur',};

export default {
  name: 'UserInfos',
  mixins: [validationMixin],
  components:{
    Loading
  },
  validations: {
    userProfile: {
      lastName: {
        required
      },
      firstName: {
        required
      },
      alias: {
        minLength: minLength(3)
      },
      birthday: {
        minLength: minLength(3),
        isLegalAge: value => {
            if (!value) {   
              return true;
            } else {
              return value && moment(value, 'DD/MM/YYYY').isValid() && moment().diff(moment(value, 'DD/MM/YYYY'), 'years') > 16
            }
        }
      },
      phone: {
        minLength: minLength(5)
      },
    },
  },
  data: () => ({
    userProfile: {},
    imageAvatar: null,
    imageUrl:'',
    editMode : false,
    errors: []
  }),
  computed: {
    lastNameErrors () {
			const errors = [];
			if (!this.$v.userProfile.lastName.$dirty) return errors
			!this.$v.userProfile.lastName.required && errors.push('Nom requis')
			return errors
		},
		firstNameErrors () {
			const errors = [];
			if (!this.$v.userProfile.firstName.$dirty) return errors
			!this.$v.userProfile.firstName.required && errors.push('Prénom requis')
			return errors
		},
		aliasErrors () {
			const errors = [];
			!this.$v.userProfile.alias.minLength && errors.push('Pseudo trop court')
			return errors
		},
		dateErrors () {
      const errors = [];
      if (!this.$v.userProfile.birthday.$dirty) return errors
      if (!this.userProfile.birthday) return errors
			!this.$v.userProfile.birthday.isLegalAge && errors.push('Vous devez avoir plus de 16 ans')
			return errors
		},
    phoneErrors () {
      const errors = [];
      !this.$v.userProfile.phone.minLength && errors.push('Veuillez mettre un numéro valide')
      return errors
    },
    userRoles(){
      if (this.userInfos && this.userInfos.roles) {
        let res = [];
        for (const role of this.userInfos.roles) {
          if (role !== 'ROLE_USER') {
            res.push({value: ROLES_TXT[role], color: ROLES_COLORS[role]});
          }
        }
        return res;
      } else {
        return [];
      }
    },
    ...mapFields('user', ['userInfos', 'loggedIn','tempProfilePicture' ,'error', 'isLoading']),
  },
  created() {
    this.getProfile(this.userInfos.id);
    this.userProfile = {
      ...this.userInfos
    };
  },
  methods: {
    saveInfos(event) {
      event.preventDefault();
      this.$v.$touch();
      if (this.$v.$invalid) {
        return false;
      }
      let user = {};  
      for (const key in this.userProfile) {
        if (this.userProfile[key].length > 0) {
          if (key === 'birthday') {
            user[key] = moment.utc(this.userProfile[key], "DD-MM-YYYY");
          } else {
            user[key] = this.userProfile[key];
          }
        }
      }

      this.updateProfile({
        user: user,
        userId : this.userProfile.id
      });
      this.editMode = !this.editMode;
    },
    uploadImage:function() {
      let formData = new FormData();
      formData.append('file', this.imageAvatar, this.imageAvatar.name);
      this.uploadProfilePicture(formData);
    },
    editProfile: function (event) {
      event.preventDefault();
      this.editMode = !this.editMode;
    },

     ...mapActions('user', ['getProfile', 'updateProfile', 'uploadProfilePicture'])
  },
  watch: {
    userInfos(newInfos) {
      if(newInfos && newInfos.id) {
        this.userProfile = {
          ...this.userInfos
        };
        if (!this.imageUrl && this.userProfile.avatar) {
          this.imageUrl = ENTRYPOINT + '/media/' +  this.userProfile.avatar.filePath;
        }
      }
    },
    tempProfilePicture(newPicture) {
      if (newPicture) {
        this.userProfile['avatar'] = newPicture.imageId;
        this.imageUrl = ENTRYPOINT + newPicture.imageUrl;
      }
    }
  }
}
</script>
